extends CharacterBody3D

@onready var camera = $Camera3D;
@onready var sounds = $"/root/Game/EventSounds";

func _input(event):
	# mouselook code
	if event is InputEventMouseMotion:
		var movement = event.relative;
		camera.rotation.x += -deg_to_rad(movement.y * 0.5);
		camera.rotation.x = clamp(camera.rotation.x,deg_to_rad(-30),deg_to_rad(75));
		camera.rotation.y += -deg_to_rad(movement.x * 0.2);

func _physics_process(delta): 
	
	# triggering sounds with keypresses
	if Input.is_action_just_pressed("1"):
		sounds.playSound("Vibe60");
	if Input.is_action_just_pressed("2"):
		sounds.playSound("Vibe64");
	if Input.is_action_just_pressed("3"):
		sounds.playSound("Vibe67");
	if Input.is_action_just_pressed("4"):
		sounds.playSound("Vibe69");
	if Input.is_action_just_pressed("space"):
		sounds.playRandom();
	
	# motion code
	var dir = Vector2(0,0);
	if Input.is_action_pressed("ui_right"): 
		dir.x += 1;
	if Input.is_action_pressed("ui_left"): 
		dir.x -= 1;
	if Input.is_action_pressed("ui_up"):
		dir.y -= 1;
	if Input.is_action_pressed("ui_down"):
		dir.y += 1;
	dir = dir.normalized().rotated(-camera.rotation.y);
	var speed = 15;
	var vel = Vector3(dir.x*speed,0,dir.y*speed);
	set_velocity(vel)
	set_up_direction(Vector3.UP)
	move_and_slide();
